<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\CustomerData;

use Flat101\EnhancedEcommerce\Model\DataLayer\CartView;
use Flat101\EnhancedEcommerce\Model\DataLayer\Impressions\ClickImpressionView;
use Flat101\EnhancedEcommerce\Model\Session;
use Magento\Customer\CustomerData\SectionSourceInterface;

class AnalyzerData implements SectionSourceInterface
{
    /** @var CartView */
    protected $cartView;

    /** @var ClickImpressionView */
    protected $clickImpressionView;

    /** @var Session */
    protected $sessionManager;

    public function __construct(
        CartView $cartView,
        ClickImpressionView $clickImpressionView,
        Session $sessionManager)
    {
        $this->cartView = $cartView;
        $this->clickImpressionView = $clickImpressionView;
        $this->sessionManager = $sessionManager;
    }

    /**
     * {@inheritdoc}
     */
    public function getSectionData(): array
    {
        return [
            'cart' => $this->cartView->getCartLayer(),
            'removeCart' => $this->cartView->getRemoveCartLayer(),
            'checkoutSteps' => $this->sessionManager->getCheckoutSteps(true),
            'behavioralEvents' => $this->sessionManager->getBehavioralEvent(true),
            'productClick' => $this->clickImpressionView->getLayer(),
        ];
    }
}
