define([
    'jquery'
], function ($) {
    'use strict';

    function initBefore() {
        window.dataLayer = window.dataLayer || [];
    }

    function dataLayerPush(data) {
        initBefore();

        if (_.has(data.ecommerce.add, 'products') && _.isArray(data.ecommerce.add.products) && data.ecommerce.add.products.length > 0) {
            cleanData(data.ecommerce.add.products);
        }
        dataLayer.push(data);
    }

    /**
     * Clean null keys
     * @param data
     */
    function cleanData(data) {
        Object.keys(data).forEach(key => data[key] === null && delete data[key]);
    }

    // Only for add to cart from PLPs (added by Layout)
    return function (options, element) {
        $(element).click(function (event) {
            event.preventDefault();

            let form = $(element).closest('form');
            let ajaxURL = form.attr('action');
            let prodId = form.find('input[name="product"]').val();

            if (_.has(options, 'click_data')&& _.isObject(options.click_data.GA4)) {
                let clickDataGa4 = JSON.stringify(options.click_data.GA4[prodId]);
                let clickDataUa = "{}";

                if (_.has(options.click_data, 'UA') && _.isObject(options.click_data.UA)) {
                    clickDataUa = JSON.stringify(options.click_data.UA[prodId]);
                }

                let dataString = $(form).serialize() + '&click_data=' + clickDataGa4 + clickDataUa;

                $.ajax({
                    type: 'POST',
                    data: dataString,
                    url: ajaxURL,
                    success: function(result, status){

                        if (_.isArray(result) && result.length > 0) {
                            result.forEach((item) => {
                                dataLayerPush(item);
                            });
                        }
                    },
                    dataType: 'json'
                });
            }
        });
    };
});
